#!/usr/bin/python

# Developed by G DATA Software
# Paul Rascagneres
# Regin detection. Argument: .evt virtual filesystem
#  #####          ######     #    #######    #
# #     #         #     #   # #      #      # #
# #               #     #  #   #     #     #   #
# #  ####         #     # #     #    #    #     #
# #     #         #     # #######    #    #######
# #     #         #     # #     #    #    #     #
#  #####          ######  #     #    #    #     #
# Disclaimer: Use at your own risk. No warranty. No liability. 



import sys
import binascii
import os

if len(sys.argv) != 2:
  print sys.argv[0],"file"
  exit(2)

if not os.path.isfile(sys.argv[1]):
  print "The file:", sys.argv[0],"does not exit"
  exit(2)
if os.stat(sys.argv[1]).st_size <= 11:
  print "The file is too small"
  exit(2)

fp = open(sys.argv[1], 'r')
SectorSize=fp.read(2)[::-1]
MaxSectorCount=fp.read(2)[::-1]
MaxFileCount=fp.read(2)[::-1]
FileTagLength=fp.read(1)[::-1]
CRC32custom=fp.read(4)[::-1]
fp.close()

print "SectorSize: ", SectorSize.encode('hex')
print "MaxSectorCount: ", MaxSectorCount.encode('hex')
print "MaxFileCount: ", MaxFileCount.encode('hex')
print "FileTagLength: ", FileTagLength.encode('hex')
print "CRC32custom: ", CRC32custom.encode('hex')

fp = open(sys.argv[1], 'r')
data=fp.read(0x7)
crc = binascii.crc32(data, 0x45)
crc2 = '%08x' % (crc & 0xffffffff)
print 'CRC of the file: %08x' % (crc & 0xffffffff)

if CRC32custom.encode('hex') == crc2:
  print sys.argv[1],": is detected as a Regin virtual filesystem."
else:
  print sys.argv[1],": is clean."


